type PublicQuery {
}

type PrivateQuery {
    allUsers(filter: UserFilter, orderBy: OrderUsersBy, first: Int, skip: Int, after: ID, last: Int, before: ID): [User] @bread(function: "browse", model: "User")
    user(id: ID, name: String, email: String, password: String, avatarUrl: String, role: Role, createdAt: DateTime, updatedAt: DateTime): User @bread(function: "read", model: "User")
}

type PublicMutation {
}

type PrivateMutation {
    createUser(name: String!, email: String!, password: String!, avatarUrl: String, role: Role!): User @bread(function: "add", model: "User")
    updateUser(id: ID!, name: String, email: String, password: String, avatarUrl: String, role: Role): User @bread(function: "edit", model: "User")
    deleteUser(id: ID!): User @bread(function: "delete", model: "User")
}

schema Public {
    query: PublicQuery
    mutation: PublicMutation
}

schema Private {
    query: PrivateQuery
    mutation: PrivateMutation
}

